<template>
  <v-text-field
    v-bind="$attrs"
    :label="$t('amount', { required: required ? '*' : '' })"
    prepend-icon="mdi-currency-usd"
    :rules="rules"
    placeholder="0.00"
    :prefix="$t('prefix')"
    v-on="$listeners"
  >
    <template v-slot:append-outer>
      <v-tooltip bottom>
        <template v-slot:activator="{ on, attrs }">
          <v-icon
            v-bind="attrs"
            v-on="on"
          >
            mdi-help-circle-outline
          </v-icon>
        </template>
        <p class="my-0">
          {{ $t('fillingInstructions.separator', { symbol: '.', symbolName: $t('fillingInstructions.symbolName') }) }}
        </p>
        <p class="my-0">
          {{ $t('fillingInstructions.thousand') }}
        </p>
        <p class="my-0">
          {{ $t('fillingInstructions.maximumDigits', { intDigitsLength: 11, decimalPrecision: 4 }) }}
        </p>
        <p class="my-0">
          {{ $t('fillingInstructions.minValue', { n: 0 }) }}
        </p>
        <p class="my-0">
          {{ $t('fillingInstructions.maxValue', { n: 99999999999.9999 }) }}
        </p>
      </v-tooltip>
    </template>
  </v-text-field>
</template>

<script>
  import {
    required,
    decimal,
    maxDecimalLength,
    maxDecimalPrecisionLength,
  } from '@/lib/validators'

  /*
  * -------------------------------------------------------------
  * -------------------------- WARNING --------------------------
  * -------------------------------------------------------------
  * Do not forget to update the template filling example and
  * field placeholder if you change the constant values below.
  * -------------------------------------------------------------
  * */
  const DECIMAL_SEPARATOR = '.'
  const INT_DIGITS_LENGTH = 11
  const DECIMAL_PRECISION = 4
  // END WARNING

  export default {
    name: 'MoneyTextField',
    props: {
      required: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    computed: {
      rules () {
        return this.required
          ? [
            required,
            decimal,
            maxDecimalLength(INT_DIGITS_LENGTH, DECIMAL_SEPARATOR),
            maxDecimalPrecisionLength(DECIMAL_PRECISION, DECIMAL_SEPARATOR),
          ]
          : []
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          prefix: 'R$',
          amount: 'Valor R$' + '{required}',
          fillingInstructions: {
            symbolName: 'ponto',
            separator: 'Utilize " {symbol} " ({symbolName}) como separador para as casas decimais.',
            thousand: 'Não insira nenhum separador para os milhares ou símbolos.',
            maximumDigits: 'Informe no máximo {intDigitsLength} dígitos inteiros e {decimalPrecision} casas decimais.',
            minValue: 'Valor mínimo: {n}',
            maxValue: 'Valor máximo: {n}',
          },
        },
        'en-US': {
          prefix: '$',
          amount: 'Amount $' + '{required}',
          fillingInstructions: {
            symbolName: 'dot',
            separator: 'Use " {symbol} " ({symbolName}) as a separator for decimal places.',
            thousand: 'Do not enter any separator for the thousands or symbols.',
            maximumDigits: 'Enter at most {intDigitsLength} significant digits and {decimalPrecision} decimal places.',
            minValue: 'Min value: {n}',
            maxValue: 'Max value: {n}',
          },
        },
      },
    },
  }
</script>
